﻿

namespace DADProblemCs;

public partial class FrmMain : Form
{
  private bool ValideDragDrop = false;
  private string ImageFileNamePath = string.Empty;
  public FrmMain()
  {
    this.InitializeComponent();
  }

  private void PbMain_DragDrop(object sender, DragEventArgs e)
  {
    if (this.ValideDragDrop)
    {
      if (this.PbMain.Image is not null) this.PbMain.Image.Dispose();
      this.PbMain.Image = null;

      using var fsi = new FrmShowImage(this.ImageFileNamePath);
      if (DialogResult.OK == fsi.ShowDialog(this))
      {
        this.ImageFileNamePath = fsi.ImageFileNamePath;
        if (this.ImageFileNamePath is not null)
          this.PbMain.Image = LoadImage(this.ImageFileNamePath);
      }
    }
  }

  private void PbMain_DragEnter(object sender, DragEventArgs e)
  {
    this.ValideDragDrop = this.ToCheckFilename(e);
    if (this.ValideDragDrop) e.Effect = DragDropEffects.Copy;
    else e.Effect = DragDropEffects.None;
  }

  private bool ToCheckFilename(DragEventArgs e)
  {
    if ((e.AllowedEffect & DragDropEffects.Copy) == DragDropEffects.Copy)
    {
      if (e.Data is null) return false;
      if (e.Data.GetData("FileDrop") is string[] data)
      {
        this.ImageFileNamePath = data[0];
        return true;
      }
    }
    return false;
  }

  private static Image LoadImage(string filename)
    => new Bitmap(filename);
}
