﻿


namespace DADProblemCs;
public partial class FrmShowImage : Form
{
  private bool ValideDragDrop = false;
  internal string ImageFileNamePath = string.Empty;

  public FrmShowImage(string filename)
  {
    this.InitializeComponent();
    this.ImageFileNamePath = filename;
    this.PbShowImage.Image = LoadImage(this.ImageFileNamePath);
  }

  private void FrmShowImage_FormClosing(object sender, FormClosingEventArgs e)
  {
    if (this.PbShowImage.Image is not null) this.PbShowImage.Image.Dispose();
    this.PbShowImage.Image = null;
  }

  private void PbShowImage_DragDrop(object sender, DragEventArgs e)
  {
    if (this.ValideDragDrop)
    {
      if (this.PbShowImage.Image is not null) this.PbShowImage.Image.Dispose();
      this.PbShowImage.Image = null;
    }
  }

  private void PbShowImage_DragEnter(object sender, DragEventArgs e)
  {
    this.ValideDragDrop = this.ToCheckFilename(e);
    if (this.ValideDragDrop) e.Effect = DragDropEffects.Copy;
    else e.Effect = DragDropEffects.None;
  }

  private bool ToCheckFilename(DragEventArgs e)
  {
    if ((e.AllowedEffect & DragDropEffects.Copy) == DragDropEffects.Copy)
    {
      if (e.Data is null) return false;
      if (e.Data.GetData("FileDrop") is string[] data)
      {
        this.ImageFileNamePath = data[0];
        return true;
      }
    }
    return false;
  }

  private static Image LoadImage(string filename)
    => new Bitmap(filename);

}
